<%@ WebService Language="c#" Codebehind="MotionService.asmx.cs" Class="ComputerConsultingPeople.MotionService" %>

using System;
using System.Web.Services;
using System.Web.Services.Protocols;
using ByteFX.Data.MySqlClient;
using System.IO;


namespace ComputerConsultingPeople
{

	[WebService( Description="A c# webservice running under MONO for the motion camera software @ http://www.lavrsen.dk/twiki/bin/view/Motion/WebHome This Webservice is incomplete and has know issues but it works pretty much as intended. ")]
	public class MotionService : System.Web.Services.WebService
	{
			
		[WebMethod (Description ="Returns an XML string of the last count events for a specific camera. For all cameras pass -1 as the camera parameter")]
		public string GetEventList (string username, string password, int camera, int year, int month, int day, int hour, int offset, int count, int order)
		{
			logRequest("GetEventList");
			if (validCredentials(username,password))
			{
				return readEventList(camera,year,month,day,hour,offset,count, order);
			}
			else
			{
				return "";
			}
		}
		
		
		[WebMethod (Description ="Returns an int representing the number of records for the query")]
		public int GetEventListCount(string username, string password, int camera, int year, int month, int day, int hour)
		{
			logRequest("GetEventListCount");
			if (validCredentials(username,password))
			{
				return countEventList(camera,year,month,day,hour);
			}
			else
			{
				return 0;
			}
		}

		/*
		
		[WebMethod (Description ="Returns an XML string of the events (max last 1000) for a specific camera within a specific hour. For all cameras pass -1 as the camera parameter ")]
		public string GetEventListByHour (string username, string password, int camera, int year, int month, int day, int hour)
		{
			logRequest("GetEventListByHour");
			if (validCredentials(username,password))
			{
			return readHourlyEventList(camera,year,month,day,hour);
			}
			else
			{
				return "";
			}
		}
		*/
			
		[WebMethod (Description ="Returns an XML string of the number events per hour for a given day and month for a specific camera camera = -1 for all cameras")]
		public string GetEventStatsByHour (string username, string password, int camera, int year, int month, int day)
		{
			logRequest("GetEventStatsByHour");
			if (validCredentials(username,password))
			{
				return readEventStatsPerHour(camera, year, month, day);
			}
			else
			{
				return "";
			}
		}
		
		[WebMethod (Description ="Returns an XML string of the number events per day for a given month for a specific camera. Camera = -1 for all cameras")]
		public string GetEventStatsByDay (string username, string password, int camera, int year, int month)
		{
			logRequest("GetEventStatsByDay");
			if (validCredentials(username,password))
			{
				return readEventStatsPerDay(camera, year, month);
			}
			else
			{
				return "";
			}
		}
		
		[WebMethod (Description ="Returns an XML string of the number events per day for a given month for a specific camera. Camera = -1 for all cameras")]
		public string GetEventStatsByMonth (string username, string password, int camera, int year)
		{
			logRequest("GetEventStatsByMonth");
			if (validCredentials(username,password))
			{
				return readEventStatsPerMonth(camera, year);
			}
			else
			{
				return "";
			}
		}
	
		[WebMethod (Description ="Returns the last Image for a specific camera. Pass -1 as the camera parameter if you just want the last saved image irrespective of camera")]
		public MotionImage GetLastImage (string username, string password, int camera)
		{
			MotionImage myImage = new MotionImage();
			myImage.Camera = camera;
			logRequest("GetLastImage");
			if (validCredentials(username,password))
			{
				 getLastFrame(myImage);
			}
			else
			{
				myImage.Error = "Invalid Credentials";
			}
			
			return myImage;
		}
		
		[WebMethod (Description ="Returns an image as specified by theImage . This name can be obtained from one of the GetEventList methods")]
		public MotionImage GetImage (string username, string password, string theImage )
		{
			MotionImage myImage = new MotionImage();
			logRequest("GetImage");
			if (validCredentials(username,password))
			{
				myImage.Filename = theImage;
				ReadImage(myImage);
				LoadImageMetaData(myImage);
			}
			else
			{
				myImage.Error = "Invalid Credentials";
			}
			return myImage;
		}
		
		[WebMethod (Description ="Deletes an image as specified by theImageFileName from the Motion events database and the filesystem.\n If successful returns an empty string otherwise string containing errors\n\nNOTE: This method will not attempt to delete a filesystem file unless the exact name passed as a parameter exists in the motion DB")]
		public string DeleteImage (string username, string password, string theImageFileName)
		{
			string retval = "";
			logRequest("DeleteImage");
			if (validCredentials(username,password))
				retval = deleteSingleImage(theImageFileName);
			else
				retval = "Invalid Credentials";
			
			return retval;
		}

		[WebMethod (Description ="Deletes all images for a specified camera and year/month from the events database and the filesystem" )]
		public string DeleteImagesForMonth (string username, string password, int cam, int year, int month)
		{
			string retval = "";
			logRequest("DeleteImagesForMonth");
			if (validCredentials(username,password))
				retval = deleteMonthImages(cam, year, month);
			else
				retval = "Invalid Credentials";
			
			return retval;
		}
			
		[WebMethod (Description ="Deletes all images for a specified camera and year/month/day from the events database and the filesystem" )]
		public string DeleteImagesForDay (string username, string password, int cam, int year, int month, int day)
		{
			string retval = "";
			logRequest("DeleteImagesForDay");
			if (validCredentials(username,password))
				retval = deleteDayImages(cam,year,month,day);
			else
				retval = "Invalid Credentials";
			
			return retval;
		}
		
		[WebMethod (Description ="Deletes all images for a specified camera and year/month/day/hour from the events database and the filesystem" )]
		public string DeleteImagesForHour (string username, string password, int cam, int year, int month, int day, int hour)
		{
			string retval = "";
			logRequest("DeleteImagesForHour");
			if (validCredentials(username,password))
				retval = deleteHourImages(cam, year, month, day, hour);
			else
				retval = "Invalid Credentials";
				
			return retval;
		}
			
			
		private void logRequest(string info)
		{
			// Nothing here but could be used to store information in a log file to see whats going on. Otherwise the webserver logs should be good enough
		}
			
		private bool validCredentials(string username, string password)
		{
			string user = System.Configuration.ConfigurationSettings.AppSettings.Get("user");
			string pass = System.Configuration.ConfigurationSettings.AppSettings.Get("password");
			if (user == username && pass == password )
				return true;
			else
				return false;
		}
			
			
		// Deletes a single image. The filename must exisit in the mysql db 
		private string deleteSingleImage(string fileName)
		{
			string retval 				= "";	
			int recsDeleted 			= 0;
			bool canDelete			= false;
			string myConnString 	= System.Configuration.ConfigurationSettings.AppSettings.Get("connectionString");
			string mySelectQuery 	= "SELECT filename FROM security  WHERE fileName = '" + fileName + "' ";
			string myDeleteQuery 	= "DELETE FROM security WHERE filename = '" + fileName + "' ";
			MySqlConnection myConnection = new MySqlConnection(myConnString);
			MySqlCommand myCommand = new MySqlCommand(mySelectQuery,myConnection);
			myConnection.Open();
		
			MySqlDataReader myReader = myCommand.ExecuteReader();
			canDelete = myReader.Read();	// True if a record was avaialable to be read;
			myReader.Close();
			
			
			if (canDelete)		// We found the filenamne in the db so lets go ahead and try and delete the file from the filesystem
			{
				retval += deleteFileSystemImage(fileName);
				if (retval.Length == 0)		// Value == 0 means the file was removed OK so lets get rid of it from the DB
				{
					myCommand = new MySqlCommand(myDeleteQuery,myConnection);
					recsDeleted = myCommand.ExecuteNonQuery();
					if (recsDeleted == 0)	// For some reason we were unable to delete the record from the DB
						retval += "For some reason the record was not deleted in the DB";
				}
			}	
			else
			{
				retval += fileName + " not found in DB\n";	
			}
			myCommand.Connection.Close();	// Close the connection
			
			return retval;
		}
	
	
		// Deletes all images for a given camera for a given hour
		private string deleteHourImages(int camera, int year, int month, int day, int hour)
		{
			string retval = "";	
			int recsDeleted = 0;
			string myConnString = System.Configuration.ConfigurationSettings.AppSettings.Get("connectionString");
			string mySelectQuery = "SELECT filename FROM security ";
			mySelectQuery += " WHERE camera = " + camera + " AND YEAR(time_stamp) = " + year + " AND MONTH(time_stamp) = " + month + " AND DAY(time_stamp) = " + day + " AND HOUR(time_stamp) = " + hour ;
			MySqlConnection myConnection = new MySqlConnection(myConnString);
			MySqlCommand myCommand = new MySqlCommand(mySelectQuery,myConnection);
			myConnection.Open();
			MySqlDataReader myReader = myCommand.ExecuteReader();
			while (myReader.Read()) 
			{
				retval +=deleteFileSystemImage(myReader.GetString(0));
				if (retval.Length > 0)		// Just report the first error
					break;
				
			}
			myReader.Close();
			
			
			
			if (retval.Length == 0) // Not such a good idea need to be a bit more clever
			{
				string myDeleteQuery = "DELETE FROM security WHERE camera = " + camera + " AND YEAR(time_stamp) = " + year + " AND MONTH(time_stamp) = " + month + " AND DAY(time_stamp) = " + day + " AND HOUR(time_stamp) = " + hour ;
				myCommand = new MySqlCommand(myDeleteQuery,myConnection);
				recsDeleted = myCommand.ExecuteNonQuery();
				if (recsDeleted == 0)
					retval += "No Files were Found in DB for camera " + camera + ", TimeFrame " + year + "." + month + "." + day + ":" + hour + "\n";
			}
			
			myConnection.Close();
			
			return retval;
		}
	

		private string deleteDayImages(int camera, int year, int month, int day)
		{
			string retval = "";	
			int recsDeleted = 0;
			string myConnString = System.Configuration.ConfigurationSettings.AppSettings.Get("connectionString");
			string mySelectQuery = "SELECT filename FROM security ";
			mySelectQuery += " WHERE camera = " + camera + " AND YEAR(time_stamp) = " + year + " AND MONTH(time_stamp) = " + month + " AND DAY(time_stamp) = " + day ;
			MySqlConnection myConnection = new MySqlConnection(myConnString);
			MySqlCommand myCommand = new MySqlCommand(mySelectQuery,myConnection);
			myConnection.Open();
			MySqlDataReader myReader = myCommand.ExecuteReader();
			while (myReader.Read()) 
			{
				retval +=deleteFileSystemImage(myReader.GetString(0));
				if (retval.Length > 0)		// Just report the first error
					break;
				
			}
			myReader.Close();
			
			if (retval.Length == 0) // Not such a good idea need to be a bit more clever
			{
				string myDeleteQuery = "DELETE FROM security WHERE camera = " + camera + " AND YEAR(time_stamp) = " + year + " AND MONTH(time_stamp) = " + month + " AND DAY(time_stamp) = " + day  ;
				myCommand = new MySqlCommand(myDeleteQuery,myConnection);
				recsDeleted = myCommand.ExecuteNonQuery();
				if (recsDeleted == 0)
					retval += "No Files were Found in DB for camera " + camera + ", TimeFrame " + year + "." + month + "." + day + "\n";
			}
			
			myConnection.Close();
			
			return retval;
		}


		
		
		private string deleteMonthImages(int camera, int year, int month)
		{
			string retval = "";	
			int recsDeleted = 0;
			string myConnString = System.Configuration.ConfigurationSettings.AppSettings.Get("connectionString");
			string mySelectQuery = "SELECT filename FROM security ";
			mySelectQuery += " WHERE camera = " + camera + " AND YEAR(time_stamp) = " + year + " AND MONTH(time_stamp) = " + month ;
			MySqlConnection myConnection = new MySqlConnection(myConnString);
			MySqlCommand myCommand = new MySqlCommand(mySelectQuery,myConnection);
			myConnection.Open();
			MySqlDataReader myReader = myCommand.ExecuteReader();
			while (myReader.Read()) 
			{
				retval +=deleteFileSystemImage(myReader.GetString(0));
				if (retval.Length > 0)		// Just report the first error
					break;
				
			}
			myReader.Close();
			
			
			
			if (retval.Length == 0) // Not such a good idea need to be a bit more clever
			{
				string myDeleteQuery = "DELETE FROM security WHERE camera = " + camera + " AND YEAR(time_stamp) = " + year + " AND MONTH(time_stamp) = " + month  ;
				myCommand = new MySqlCommand(myDeleteQuery,myConnection);
				recsDeleted = myCommand.ExecuteNonQuery();
				if (recsDeleted == 0)
					retval += "No Files were Found in DB for camera " + camera + ", TimeFrame " + year + "." + month + "\n";
			}
			
			myConnection.Close();
			
			return retval;
		}


		private string deleteFileSystemImage(string fileName)
		{
			string retval = "";
			if (File.Exists(fileName))
				try
				{
					File.Delete(fileName);
				}
				catch (Exception e)
				{
					retval += fileName + " " + e.Message;
				}
				
			return retval;
		}
	

		// Opens the mysql db and reads the last count events. if camera is > -1 it reads only for that camera
		private string readEventList( int camera, int year, int month, int day, int hour, int offset, int count, int order)
		{
			int clauseCount = 0;
			string retval = "";	
			string myConnString = System.Configuration.ConfigurationSettings.AppSettings.Get("connectionString");

			string mySelectQuery = "SELECT camera, filename, frame, file_type, text_left, time_stamp from security ";
			
			if (camera > -1)
				mySelectQuery += concatString(clauseCount++) + "camera = " + camera;

			if (hour > -1)
					mySelectQuery += concatString(clauseCount++) + "HOUR(time_stamp) = " + hour;

			if (day > 0)
					mySelectQuery += concatString(clauseCount++) + "DAY(time_stamp) = " + day;

			if (month > 0)
					mySelectQuery += concatString(clauseCount++) + "MONTH(time_stamp) = " + month;

			if (year > 0)
					mySelectQuery += concatString(clauseCount++) + "YEAR(time_stamp) = " + year;
			
			if (order == 0)	
				mySelectQuery +=" ORDER BY time_stamp ,frame" ;
			else
				mySelectQuery +=" ORDER BY time_stamp DESC ,frame DESC";
		
			mySelectQuery +=" LIMIT " + offset + "," + count;
		
		//return mySelectQuery ;
			MySqlConnection myConnection = new MySqlConnection(myConnString);
	    	MySqlCommand myCommand = new MySqlCommand(mySelectQuery,myConnection);
	   		myConnection.Open();
		    MySqlDataReader myReader;
	    	myReader = myCommand.ExecuteReader();
			retval += formatAsXml(myReader);
	    	myReader.Close();
		    myConnection.Close();
			return retval;
		}
		
		
		
		
		
		// Opens the mysql db and reads the last count events. if camera is > -1 it reads only for that camera
		private int countEventList( int camera, int year, int month, int day, int hour)
		{
			int clauseCount = 0;
			int retval = 0;	
			string myConnString = System.Configuration.ConfigurationSettings.AppSettings.Get("connectionString");

			string mySelectQuery = "SELECT count(*) FROM security ";
			
			if (camera > -1)
				mySelectQuery += concatString(clauseCount++) + "camera = " + camera;

			if (hour > -1)
					mySelectQuery += concatString(clauseCount++) + "HOUR(time_stamp) = " + hour;

			if (day > 0)
					mySelectQuery += concatString(clauseCount++) + "DAY(time_stamp) = " + day;

			if (month > 0)
					mySelectQuery += concatString(clauseCount++) + "MONTH(time_stamp) = " + month;

			if (year > 0)
					mySelectQuery += concatString(clauseCount++) + "YEAR(time_stamp) = " + year;
			
			MySqlConnection myConnection = new MySqlConnection(myConnString);
	    	MySqlCommand myCommand = new MySqlCommand(mySelectQuery,myConnection);
	   		myConnection.Open();
		    MySqlDataReader myReader = myCommand.ExecuteReader();

			if (myReader.Read() )
				retval = myReader.GetInt32(0);

	    	myReader.Close();
		    myConnection.Close();
			return retval;
		}
		
		
		
		
		
		
		
		
		
		
		private string concatString(int count)
		{
		
				if (count > 0)
					return " AND ";
				else
					return " WHERE ";
		}
	
		
		// Opens the mysql db and reads the last count events. if camera is > -1 it reads only for that camera
		private string readHourlyEventList(int camera, int year, int month, int day, int hour)
		{
			string retval = "";	
			string myConnString = System.Configuration.ConfigurationSettings.AppSettings.Get("connectionString");
			string mySelectQuery = "SELECT camera, filename, frame, file_type, text_left, time_stamp from security ";
			mySelectQuery += " WHERE YEAR(time_stamp) = " + year + " AND MONTH(time_stamp) = " + month + " AND DAY(time_stamp) = " + day + " AND HOUR(time_stamp) = " + hour  + " ";
			if (camera > -1)
				mySelectQuery += " AND camera = " + camera + " ";
				
			mySelectQuery +="ORDER BY time_stamp DESC,frame DESC LIMIT 1000";
			MySqlConnection myConnection = new MySqlConnection(myConnString);
	    	MySqlCommand myCommand = new MySqlCommand(mySelectQuery,myConnection);
	   		myConnection.Open();
		    MySqlDataReader myReader;
	    	myReader = myCommand.ExecuteReader();
			retval += formatAsXml(myReader);
	    	myReader.Close();
		    myConnection.Close();
			return retval;
		}

		
		// Opens the mysql db and reads the number of events per device grouped by Hour
		private string readEventStatsPerHour(int camera, int year, int month, int day)
		{
			string retval = "";	
			string myConnString = System.Configuration.ConfigurationSettings.AppSettings.Get("connectionString");
			string mySelectQuery = "SELECT  HOUR(time_stamp) , count(*) as total , camera FROM security ";
			mySelectQuery += " WHERE YEAR(time_stamp) = " + year + " AND MONTH(time_stamp) = " + month + " AND DAY(time_stamp) = " + day + " ";
			if (camera > -1)
				mySelectQuery += " AND camera = " + camera + " ";
				
			mySelectQuery += " GROUP BY HOUR(time_stamp), camera  ";	
			mySelectQuery +="ORDER BY HOUR(time_stamp)  ";
			MySqlConnection myConnection = new MySqlConnection(myConnString);
	    	MySqlCommand myCommand = new MySqlCommand(mySelectQuery,myConnection);
	   		myConnection.Open();
		    MySqlDataReader myReader;
	    	myReader = myCommand.ExecuteReader();
			retval += "<?xml version='1.0' encoding='ISO-8859-1'?>\n";
			retval +="<events>\n";  
		    while (myReader.Read()) 
			{
	       		retval += "<summary>\n";
				retval += "<total>"		+ myReader.GetInt32(1) 	+ "</total>\n";
				retval += "<interval>"		+ myReader.GetInt32(0) 	+ "</interval>\n";
				retval += "<camera>"		+ myReader.GetInt32(2) 	+ "</camera>\n";
				retval +="</summary>\n";
		    }
			retval += "</events>"; 
	    	myReader.Close();
		    myConnection.Close();
			return retval;
		}
		
		
		// Opens the mysql db and reads the number of events per device grouped by Day
		private string readEventStatsPerDay(int camera, int year, int month)
		{
			string retval = "";	
			string myConnString = System.Configuration.ConfigurationSettings.AppSettings.Get("connectionString");

			string mySelectQuery = "SELECT  DAY(time_stamp) , count(*) as total, camera FROM security ";
			mySelectQuery += " WHERE YEAR(time_stamp) = " + year + " AND MONTH(time_stamp) = " + month + "  ";
			if (camera > -1)
				mySelectQuery += " AND camera = " + camera + " ";
				
			mySelectQuery += " GROUP BY DAY(time_stamp), camera ";	
			mySelectQuery +="ORDER BY DAY(time_stamp)  ";
			
						
			MySqlConnection myConnection = new MySqlConnection(myConnString);
	    	MySqlCommand myCommand = new MySqlCommand(mySelectQuery,myConnection);
	   		myConnection.Open();
		    MySqlDataReader myReader;
	    	myReader = myCommand.ExecuteReader();
	
			retval += "<?xml version='1.0' encoding='ISO-8859-1'?>\n";
			retval +="<events>\n";  
			
		    while (myReader.Read()) 
			{
	       		retval += "<summary>\n";
				retval += "<total>"		+ myReader.GetInt32(1) 	+ "</total>\n";
				retval += "<interval>"		+ myReader.GetInt32(0) 	+ "</interval>\n";
				retval += "<camera>"		+ myReader.GetInt32(2) 	+ "</camera>\n";
				retval +="</summary>\n";
		    }


			retval += "</events>"; 
		
	    	myReader.Close();
		    myConnection.Close();
			return retval;
		
		}
				
		// Opens the mysql db and reads the number of events per device grouped by Month
		private string readEventStatsPerMonth(int camera, int year)
		{
			string retval = "";	
			string myConnString = System.Configuration.ConfigurationSettings.AppSettings.Get("connectionString");
			string mySelectQuery = "SELECT  MONTH(time_stamp) , count(*) as total, camera FROM security ";
			mySelectQuery += " WHERE YEAR(time_stamp) = " + year +  "  ";
			if (camera > -1)
				mySelectQuery += " AND camera = " + camera + " ";
				
			mySelectQuery += " GROUP BY MONTH(time_stamp), camera ";	
			mySelectQuery +="ORDER BY MONTH(time_stamp)  ";
			MySqlConnection myConnection = new MySqlConnection(myConnString);
	    	MySqlCommand myCommand = new MySqlCommand(mySelectQuery,myConnection);
	   		myConnection.Open();
		    MySqlDataReader myReader;
	    	myReader = myCommand.ExecuteReader();
	
			retval += "<?xml version='1.0' encoding='ISO-8859-1'?>\n";
			retval +="<events>\n";  
		    while (myReader.Read()) 
			{
	       		retval += "<summary>\n";
				retval += "<total>"		+ myReader.GetInt32(1) 	+ "</total>\n";
				retval += "<interval>"		+ myReader.GetInt32(0) 	+ "</interval>\n";
				retval += "<camera>"		+ myReader.GetInt32(2) 	+ "</camera>\n";
				retval +="</summary>\n";
		    }
			retval += "</events>"; 
	    	myReader.Close();
		    myConnection.Close();
			return retval;
		
		}

		
		
		// formats the data as xml
		private string formatAsXml(MySqlDataReader myReader)
		{
		string retval = "";
		retval += "<?xml version='1.0' encoding='ISO-8859-1'?>\n";
		retval +="<events>\n";  
		
		    while (myReader.Read()) 
			{
			
	       		retval += "<event>\n";
				retval += "<camera>"	+ myReader.GetInt32(0) 	+ "</camera>\n";
				retval += "<filename>"	+ myReader.GetString(1) 	+ "</filename>\n";
				retval += "<frame>"		+ myReader.GetInt32(2) 	+ "</frame>\n";
				retval += "<type>"		+ myReader.GetInt32(3) 	+ "</type>\n";
				retval += "<textleft>"	+ myReader.GetString(4) 	+ "</textleft>\n";
				retval += "<timestamp>"	+ myReader.GetDateTime(5).ToString() 	+ "</timestamp>\n";
				retval +="</event>\n";
		    }
			retval += "</events>"; 
			return retval;
		}
		
		// reads the db and loads the image for the last event. If camera > -1 will load the last image for that camera		
		private void getLastFrame(MotionImage mi)
		{
		
			string myConnString = System.Configuration.ConfigurationSettings.AppSettings.Get("connectionString");
			string mySelectQuery = "SELECT camera, filename, frame, file_type, text_left, time_stamp from security ";
			if (mi.Camera > -1)
				mySelectQuery += " WHERE camera = " + mi.Camera + " ";
				
			mySelectQuery +="ORDER BY time_stamp DESC, frame DESC LIMIT 1";
			
	    	MySqlConnection myConnection = new MySqlConnection(myConnString);
	    	MySqlCommand myCommand = new MySqlCommand(mySelectQuery,myConnection);
	   		myConnection.Open();
		    MySqlDataReader myReader;
	    	myReader = myCommand.ExecuteReader();
		    
			if (myReader.Read())
			{
				mi.Camera = myReader.GetInt32(0);
				mi.Filename = myReader.GetString(1);
				mi.Frame = myReader.GetInt32(2);
				mi.Type = myReader.GetInt32(3);
				mi.TextLeft = myReader.GetString(4);
				mi.TimeStamp = myReader.GetDateTime(5).ToString();
				ReadImage(mi);	
				myReader.Close();
				myConnection.Close();
			}
			else
			{
				mi.Error = "Nothing found";
			}
		}


		// Read the data held in the mysql table for the image with given filename
		private void LoadImageMetaData(MotionImage mi)
		{
	
			string myConnString = System.Configuration.ConfigurationSettings.AppSettings.Get("connectionString");
			string mySelectQuery = "SELECT camera, filename, frame, file_type, text_left, time_stamp from security ";
			mySelectQuery += " WHERE filename = '"+ mi.Filename + "' ";
			mySelectQuery +="ORDER BY time_stamp DESC, frame DESC LIMIT 1";
			
	    	MySqlConnection myConnection = new MySqlConnection(myConnString);
	    	MySqlCommand myCommand = new MySqlCommand(mySelectQuery,myConnection);
	   		myConnection.Open();
		    MySqlDataReader myReader;
	    	myReader = myCommand.ExecuteReader();
		    
			if (myReader.Read())
			{
				mi.Camera = myReader.GetInt32(0);
				mi.Filename = myReader.GetString(1);
				mi.Frame = myReader.GetInt32(2);
				mi.Type = myReader.GetInt32(3);
				mi.TextLeft = myReader.GetString(4);
				mi.TimeStamp = myReader.GetDateTime(5).ToString();
				ReadImage(mi);	
				myReader.Close();
				myConnection.Close();
			}
			else
			{
				mi.Error = "Nothing found";
			}
			
			return;
		}

		
		// Reads the image from the filesystem	
		private void ReadImage(MotionImage mi)
		{
			byte[] _image = new byte[0];
			try
			{
				FileStream fs = File.OpenRead(mi.Filename);
				mi.Image  = new byte[fs.Length];
				ReadToByte(fs,mi.Image);
				fs.Close();
			}
			catch (Exception e)
			{
				mi.Error = "FAILED " + e.Message + " " +  e.Source ;
			}
		}

		// reads a filestream into a byte array
		private void ReadToByte (Stream stream, byte[] data)
		{
			int offset=0;
			int remaining = data.Length;
			while (remaining > 0)
			{
				int read = stream.Read(data, offset, remaining);
				if (read <= 0)
					throw new EndOfStreamException 
						(String.Format("End of stream reached with {0} bytes left to read", remaining));
				remaining -= read;
				offset += read;
			}
		}
	}
	
	
	// Simple class used to transfer the image data
	public class MotionImage
	{
		private byte[] _image;
		private int _camera;
		private string _fileName;
		private int _frame;
		private int _type;
		private string _text_left;
		private string _time_stamp;
		private string _error;
		
		
		public byte[]	Image			{get {return _image;}			set	{_image		= value;}	}	
		public int 		Camera			{get {return _camera;}		set	{_camera	= value;}	}	
		public string	Filename			{get {return _fileName;}		set	{_fileName	= value;}	}	
		public int 		Frame			{get {return _frame;}			set	{_frame	= value;}	}			
		public int 		Type				{get {return _type;}			set	{_type	= value;}	}					
		public string	TextLeft			{get {return _text_left;}		set	{_text_left	= value;}	}					
		public string	TimeStamp		{get {return _time_stamp;}	set	{_time_stamp	= value;}	}					
		public string	Error				{get {return _error;}			set	{_error	= value;}	}					
	
		public MotionImage()
		{
		 _image 			= new byte[0];
		 _camera		= -1;
		 _fileName		= "";
		_frame			= 0;
		_type			= 0;
		_text_left		= "";
		_time_stamp	= "";
		_error			= "";
		}
	}
	
}
